from elements import *
from funciones import *
import pygame,sys
from pygame.locals import *
from time import time
from json import loads,dumps
from random import choice,randint

HEIGHT	= 600
WIDTH	= 800
FPS		= 20
pygame.mixer.pre_init(44100,-16,1,512)
pygame.mixer.init()
pygame.init() #Iniciar Pygame
Screen 		= pygame.display.set_mode((WIDTH,HEIGHT))
pygame.display.set_caption("Pydle")
GameClock 	= pygame.time.Clock()
MenuBG 		= pygame.Surface((200,600))
GameBG 		= pygame.Surface((600,600))
MenuBG.fill((255,0,0))
GameBG.fill((0,122,0))
Campo 		= [[RandomBuild() for n in range(6)] if x%2==0 else [RandomBuild()  for n in range(5)] for x in range(10)]
preganancia 	= 0
promganancia	= 0
Ganancia 		= 0

#for linea in Campo:
#	print linea

GameLoop 	= True
MenuTile	= pygame.image.load("PNG/"+"Menu.png").convert_alpha()
OkBox		= pygame.image.load("PNG/"+"OKB.png").convert_alpha()
NoBox		= pygame.image.load("PNG/"+"NOB.png").convert_alpha()
HelpMenu		= pygame.image.load("PNG/"+"Help.png").convert_alpha()
SplashScreen	= pygame.image.load("PNG/"+"Splash.png").convert_alpha()
Coins			= [pygame.mixer.Sound("Sounds/C{0}.ogg".format(x)) for x in range(1,5)]
Buildings 		= [pygame.mixer.Sound("Sounds/B{0}.ogg".format(x)) for x in range(1,6)]
Upg 	= pygame.mixer.Sound("Sounds/U.ogg")
Delete 	= pygame.mixer.Sound("Sounds/D.ogg")

BlockSprites = {
	"BS"	: [pygame.image.load("PNG/"+"BS"+str(n)+".png").convert_alpha() for n in range(4)],
	"RS"	: [pygame.image.load("PNG/"+"RS"+str(n)+".png").convert_alpha() for n in range(4)],
	"BB"	: [pygame.image.load("PNG/"+"BB"+str(n)+".png").convert_alpha() for n in range(5)],
	"RB"	: [pygame.image.load("PNG/"+"RB"+str(n)+".png").convert_alpha() for n in range(5)],
	"BDS"	: [pygame.image.load("PNG/"+"BDS"+str(n)+".png").convert_alpha() for n in range(4)],
	"RDS"	: [pygame.image.load("PNG/"+"RDS"+str(n)+".png").convert_alpha() for n in range(4)],
	"NN"	: [pygame.image.load("PNG/"+"NN"+str(n)+".png").convert_alpha() for n in range(1)],
	"BMC"	: [pygame.image.load("PNG/"+"BMC"+str(n)+".png").convert_alpha() for n in range(7)],
	"RMC"	: [pygame.image.load("PNG/"+"RMC"+str(n)+".png").convert_alpha() for n in range(7)],
	"BLB"	: [pygame.image.load("PNG/"+"BLB"+str(n)+".png").convert_alpha() for n in range(6)],
	"RLB"	: [pygame.image.load("PNG/"+"RLB"+str(n)+".png").convert_alpha() for n in range(6)],
}

Menudisplay = [["BS","RS"],["BDS","RDS"],["BB","RB"],["BMC","RMC"],["BLB","RLB"]]

MenuCollide = {
	"BS"	: pygame.Rect((0,100),(75,100)),	"RS":pygame.Rect((125,100),(75,100)),
	"BB"	: pygame.Rect((0,300),(75,100)),	"RB":pygame.Rect((125,300),(75,100)),
	"BDS"	: pygame.Rect((0,200),(75,100)),	"RDS":pygame.Rect((125,200),(75,100)),
	"BMC"	: pygame.Rect((0,400),(75,100)),	"RMC":pygame.Rect((125,400),(75,100)),
	"BLB"	: pygame.Rect((0,500),(75,100)),	"RLB":pygame.Rect((125,500),(75,100))
}
UpgradeCollide = {
	"BS"	: pygame.Rect((92,125),(17,25)),	"RS" : pygame.Rect((92,150),(17,25)),
	"BB"	: pygame.Rect((92,325),(17,25)),	"RB" : pygame.Rect((92,350),(17,25)),
	"BDS"	: pygame.Rect((92,225),(17,25)),	"RDS": pygame.Rect((92,250),(17,25)),
	"BMC"	: pygame.Rect((92,425),(17,25)),	"RMC": pygame.Rect((92,450),(17,25)),
	"BLB"	: pygame.Rect((92,525),(17,25)),	"RLB": pygame.Rect((92,550),(17,25))
}

BigFont 	= pygame.font.Font("fuentes/tarzeau_ocr_a.ttf", 20)
SmallFont 	= pygame.font.Font("fuentes/tarzeau_ocr_a.ttf", 15)
SmallerFont = pygame.font.Font("fuentes/tarzeau_ocr_a.ttf", 10)
Selected	= -1
PointerMode	= 0  #Point| Build | Destroy
Posible		= 0
Modes		= {0:"Neutro",1:"Construir",2:"Demoler"}
Tobuild		= ""
Points 		= 150
Frame		= 0

try:
	with open("Pydle.save") as rf:
		savedata	= rf.readline()
		savedata	= loads(savedata)
		BLOCKS		= savedata["BLOCKS"]
		Campo		= savedata["Campo"]
		Points		= savedata["Points"]

except Exception,texto:
	print "Error cargando partida guardada..."

PrintPoints		= AdaptarPuntos(Points)
PrintProm		= AdaptarPuntos(promganancia)

while GameLoop:
	Frame+=1
	pygame.display.set_caption("Jugando Pydle - ${0} + {1} por segundo!! a {2} FPS".format(PrintPoints,PrintProm,FPS))
	GameClock.tick(FPS)
	Screen.blit(MenuBG,(0,0))
	mp = pygame.mouse.get_pos()
	Screen.blit(GameBG,(200,0))
	GameBG.fill((51,128,0)) #FillColor PisoPasto
	MenuBG.fill((204,250,250))
	MenuBG.blit(MenuTile,(0,0))
	pygame.draw.line(MenuBG, (0,0,0), (75,100), (75,600),3)
	pygame.draw.line(MenuBG, (0,0,0), (125,100), (125,600),3)
	Coords			= CoordenadasEdificios(Campo)			#Funcion para mechones
	Campo,Ganancia	= ProcesarCampo(Campo)
	Points			+= Ganancia
	preganancia		+= Ganancia

	if Frame==20:
		promganancia	= preganancia
		preganancia 	= 0
		Frame 			= 0

	if Ganancia>0:
		Coins[randint(1,3)].play()

	Selected	= SeleccionEdificio(mp)

	for blockindex in range(len(Coords)): 
		Block,state,(coordx,coordy) = Coords[blockindex]
		GameBG.blit(BlockSprites[Block][state],(coordx,coordy))
		if Selected!=-1 and Selected==blockindex and PointerMode!=0:
			if PointerMode==2 or (PointerMode==1 and not PosibleConstruir(mp,Campo)):
				GameBG.blit(NoBox,Coords[Selected][2])

			else:
				GameBG.blit(BlockSprites[Tobuild][0],Coords[Selected][2])
				GameBG.blit(OkBox,Coords[Selected][2])

	PrintPoints		  = AdaptarPuntos(Points)
	PrintProm 		  = AdaptarPuntos(promganancia)
	AdaptedPointsText = BigFont.render("${0}".format(PrintPoints),True,(0,0,0))
	ProfitText		  = SmallFont.render("+${0}/s".format(AdaptarPuntos(promganancia)),True,(0,0,0))
	NormalPointsText  = SmallerFont.render("${0}".format(Points),True,(0,0,0))
	MenuBG.blit(AdaptedPointsText,(40,10))
	MenuBG.blit(ProfitText,(40,40))
	MenuBG.blit(NormalPointsText,(0,0))
	GameBG.blit(SmallFont.render("Modo:{0} {1}".format(Modes[PointerMode],Tobuild),True,(255,255,255)),(400,0))
	for row in range(1,6): #Implementar para leer dict BLOCKS
		for col in [0,1]:
			if BLOCKS[Menudisplay[row-1][0]]["Tipo"]=="S":
				MenuBG.blit(SmallerFont.render("+$"+AdaptarPuntos(BLOCKS[Menudisplay[row-1][0]]["Ganancia"]),True,(0,255,0)),(3,100*row))
				MenuBG.blit(SmallerFont.render("+$"+AdaptarPuntos(BLOCKS[Menudisplay[row-1][1]]["Ganancia"]),True,(0,255,0)),(135,100*row))

			else:
				MenuBG.blit(SmallerFont.render("+"+AdaptarPuntos(BLOCKS[Menudisplay[row-1][0]]["Ganancia"])+"%",True,(0,255,0)),(3,100*row))
				MenuBG.blit(SmallerFont.render("+"+AdaptarPuntos(BLOCKS[Menudisplay[row-1][1]]["Ganancia"])+"%",True,(0,255,0)),(135,100*row))

			MenuBG.blit(SmallerFont.render("$"+AdaptarPuntos(BLOCKS[Menudisplay[row-1][0]]["Mejora"]),True,(255,255,255)),(76,100*row))
			MenuBG.blit(SmallerFont.render("$"+AdaptarPuntos(BLOCKS[Menudisplay[row-1][0]]["Precio"]),True,(0,0,255)),(5,100*row+80))
			MenuBG.blit(SmallerFont.render("$"+AdaptarPuntos(BLOCKS[Menudisplay[row-1][1]]["Mejora"]),True,(255,255,255)),(76,100*row+80))
			MenuBG.blit(SmallerFont.render("$"+AdaptarPuntos(BLOCKS[Menudisplay[row-1][1]]["Precio"]),True,(255,0,0)),(138,100*row+80))
			continue
		
	for event in pygame.event.get():

		if event.type==QUIT:
			print "Exportando"
			with open("Pydle.save","w") as wf:
				wf.write(dumps({"BLOCKS":BLOCKS,"Campo":Campo,"Points":Points}))
			GameLoop = 0
			break

		if event.type == MOUSEBUTTONDOWN:
			if event.button==1: #LMB
				mp=pygame.mouse.get_pos()

				if PointerMode==1 and PosibleConstruir(mp,Campo): #Construir
					Campo,BLOCKS,Points = Construir(mp,Tobuild,Campo,BLOCKS,Points)
					Buildings[randint(0,4)].play()
					PointerMode		= 0
					Tobuild			= ""

				if PointerMode==2: #Demoler
					Campo,BLOCKS=Demoler(mp,Campo,BLOCKS)
					Delete.play()
					PointerMode	= 0
					Tobuild		= ""

				for bl in MenuCollide:
					if MenuCollide[bl].collidepoint(mp):
						if Points>BLOCKS[bl]["Precio"]:
							PointerMode	= 1
							Tobuild		= bl

				for up in UpgradeCollide:
					if UpgradeCollide[up].collidepoint(mp):
						if Points>BLOCKS[up]["Mejora"]:
							BLOCKS,Points=Mejora(up,BLOCKS,Points)
							Upg.play()

				if distancia(mp,(180,80))<15:
					PointerMode	= 2
					Tobuild		= ""
				
			if event.button==3: #RMB
				PointerMode	= 0
				Tobuild		= ""

	if distancia(mp,(25,80))<15:
		Screen.blit(HelpMenu,(0,0))
	pygame.display.flip()
	
print "Pygame Quit"
pygame.time.wait(1)
pygame.quit()
print "Exit"
exit()